#!/usr/bin/env python

import re
from commons.pyRepetUnit.components.AbstractProgramLauncher import AbstractProgramLauncher

class removeDescriptionInFastaHeaderProgramLauncher(AbstractProgramLauncher):

    def __init__( self ):
        AbstractProgramLauncher.__init__( self )
        self._formatInFile = "fasta"
                
    def run( self ):
        self.checkInput()
        fastaHandler = open(self.getInputFile(), "r")
        lines = fastaHandler.readlines()
        fastaHandler.close()
        newFastaName = ".".join([self.getInputFile().split(".")[0], "preprocessed", "fasta"])
        
        self._writePreprocessedFastaFile(lines, newFastaName)
        
    def _writePreprocessedFastaFile(self, lines, newFastaName):
        newFastaHandler = open(newFastaName, "w")
        for line in lines:
            if re.match(">", line):
                newLine = line.split(" ",1)[0] + "\n"
                newFastaHandler.write(newLine)
            else:
                newFastaHandler.write(line)
        newFastaHandler.close()

        
        
        
if __name__ == "__main__":
    i = removeDescriptionInFastaHeaderProgramLauncher()
    i.checkAttributesFromCmdLine()
    i.run()
